import requests
from bs4 import BeautifulSoup
import re
import jieba

editors = []
descriptions = ''


def crawlOnePageSchoolNews(page_url):
    global descriptions
    res0 = requests.get(page_url)
    res0.encoding = 'UTF-8'
    soup0 = BeautifulSoup(res0.text, 'html.parser')
    news = soup0.select('.news-list > li')
    for n in news:
        print('新闻描述：' + n.a.select('.news-list-description')[0].text)
        print('新闻来源：' + n.a.select('.news-list-info > span')[1].text)
        descriptions = descriptions + ' ' + n.a.select('.news-list-description')[0].text
        editors.append(n.a.select('.news-list-info > span')[1].text.split(' ')[0])


crawlOnePageSchoolNews('http://news.gzcc.cn/html/xiaoyuanxinwen/')

pageURL = 'http://news.gzcc.cn/html/xiaoyuanxinwen/{}.html'
res = requests.get('http://news.gzcc.cn/html/xiaoyuanxinwen/')
res.encoding = 'UTF-8'
soup = BeautifulSoup(res.text, 'html.parser')
newsSum = int(re.search('(\d*)条', soup.select('a.a1')[0].text).group(1))
if newsSum % 10:
    pageSum = int(newsSum / 10) + 1
else:
    pageSum = int(newsSum / 10)

for i in range(2, pageSum+1):
    crawlOnePageSchoolNews(pageURL.format(i))

with open('punctuation.txt', 'r', encoding='UTF-8') as punctuationFile:
    for punctuation in punctuationFile.readlines():
        descriptions = descriptions.replace(punctuation[0], ' ')

with open('meaningless.txt', 'r', encoding='UTF-8') as meaninglessFile:
    mLessSet = set(meaninglessFile.read().split('\n'))
mLessSet.add(' ')

# 加载保留字
with open('reservedWord.txt', 'r', encoding='UTF-8') as reservedWordFile:
    reservedWordSet = set(reservedWordFile.read().split('\n'))
    for reservedWord in reservedWordSet:
        jieba.add_word(reservedWord)


keywordList = list(jieba.cut(descriptions))
keywordSet = set(keywordList) - mLessSet  # 将无意义词从词语集合中删除

keywordDict = {}
# 统计出词频字典
for word in keywordSet:
    keywordDict[word] = keywordList.count(word)

# 对词频进行排序
keywordListSorted = list(keywordDict.items())
keywordListSorted.sort(key=lambda e: e[1], reverse=True)
# 将所有词频写出到txt做词云分析
for topWordTup in keywordListSorted:
    print(topWordTup)
    with open('word.txt', 'a+', encoding='UTF-8') as wordFile:
        for i in range(0, topWordTup[1]):
            wordFile.write(topWordTup[0]+'\n')
